*** a/src/backend/executor/execQual.c
--- b/src/backend/executor/execQual.c
***************
*** 4410,4415 **** ExecInitExpr(Expr *node, PlanState *parent)
--- 4410,4416 ----
  
  					astate->args = (List *) ExecInitExpr((Expr *) aggref->args,
  														 parent);
+ 					astate->orddirectargs = (List *) ExecInitExpr((Expr *) aggref->orddirectargs, parent);
  					astate->aggfilter = ExecInitExpr(aggref->aggfilter,
  													 parent);
  
*** a/src/backend/executor/functions.c
--- b/src/backend/executor/functions.c
***************
*** 381,387 **** sql_fn_post_column_ref(ParseState *pstate, ColumnRef *cref, Node *var)
  								  list_make1(subfield),
  								  list_make1(param),
  								  NIL, NULL, false, false, false,
! 								  NULL, true, cref->location);
  	}
  
  	return param;
--- 381,387 ----
  								  list_make1(subfield),
  								  list_make1(param),
  								  NIL, NULL, false, false, false,
! 								  false, NULL, true, cref->location);
  	}
  
  	return param;
*** a/src/backend/executor/nodeAgg.c
--- b/src/backend/executor/nodeAgg.c
***************
*** 105,110 ****
--- 105,112 ----
   */
  typedef struct AggStatePerAggData
  {
+ 	NodeTag type;
+ 	
  	/*
  	 * These values are set up during ExecInitAgg() and do not change
  	 * thereafter:
***************
*** 114,119 **** typedef struct AggStatePerAggData
--- 116,124 ----
  	AggrefExprState *aggrefstate;
  	Aggref	   *aggref;
  
+ 	/* Pointer to parent AggState node */
+ 	AggState   *aggstate;
+ 
  	/* number of input arguments for aggregate function proper */
  	int			numArguments;
  
***************
*** 126,137 **** typedef struct AggStatePerAggData
  
  	/*
  	 * fmgr lookup data for transfer functions --- only valid when
! 	 * corresponding oid is not InvalidOid.  Note in particular that fn_strict
! 	 * flags are kept here.
  	 */
  	FmgrInfo	transfn;
  	FmgrInfo	finalfn;
  
  	/* Input collation derived for aggregate */
  	Oid			aggCollation;
  
--- 131,152 ----
  
  	/*
  	 * fmgr lookup data for transfer functions --- only valid when
! 	 * corresponding oid is not InvalidOid.
  	 */
  	FmgrInfo	transfn;
  	FmgrInfo	finalfn;
  
+ 	/*
+ 	 * If >0, aggregate as a whole is strict (skips null input)
+ 	 * The value specifies how many columns to check; normal aggs
+ 	 * only check numArguments, while ordered set functions check
+ 	 * numInputs.
+ 	 *
+ 	 * Ordered set functions have a separate strictness state for
+ 	 * the finalfn, which is tested separately.
+ 	 */
+ 	int         numStrict;
+ 
  	/* Input collation derived for aggregate */
  	Oid			aggCollation;
  
***************
*** 204,209 **** typedef struct AggStatePerAggData
--- 219,227 ----
  	 */
  
  	Tuplesortstate *sortstate;	/* sort object, if DISTINCT or ORDER BY */
+ 
+ 	int64 number_of_rows;		/* number of rows */
+ 
  }	AggStatePerAggData;
  
  /*
***************
*** 300,305 **** initialize_aggregates(AggState *aggstate,
--- 318,325 ----
  		AggStatePerAgg peraggstate = &peragg[aggno];
  		AggStatePerGroup pergroupstate = &pergroup[aggno];
  
+ 		peraggstate->number_of_rows = 0;
+ 
  		/*
  		 * Start a fresh sort operation for each DISTINCT/ORDER BY aggregate.
  		 */
***************
*** 383,396 **** advance_transition_function(AggState *aggstate,
  	MemoryContext oldContext;
  	Datum		newVal;
  	int			i;
  
! 	if (peraggstate->transfn.fn_strict)
  	{
  		/*
  		 * For a strict transfn, nothing happens when there's a NULL input; we
  		 * just keep the prior transValue.
  		 */
! 		for (i = 1; i <= numArguments; i++)
  		{
  			if (fcinfo->argnull[i])
  				return;
--- 403,419 ----
  	MemoryContext oldContext;
  	Datum		newVal;
  	int			i;
+ 	int         numStrict = peraggstate->numStrict;
  
! 	Assert(OidIsValid(peraggstate->transfn_oid));
! 
! 	if (numStrict > 0)
  	{
  		/*
  		 * For a strict transfn, nothing happens when there's a NULL input; we
  		 * just keep the prior transValue.
  		 */
! 		for (i = 1; i <= numStrict; i++)
  		{
  			if (fcinfo->argnull[i])
  				return;
***************
*** 506,529 **** advance_aggregates(AggState *aggstate, AggStatePerGroup pergroup)
  
  		if (peraggstate->numSortCols > 0)
  		{
  			/* DISTINCT and/or ORDER BY case */
  			Assert(slot->tts_nvalid == peraggstate->numInputs);
  
  			/*
  			 * If the transfn is strict, we want to check for nullity before
  			 * storing the row in the sorter, to save space if there are a lot
! 			 * of nulls.  Note that we must only check numArguments columns,
! 			 * not numInputs, since nullity in columns used only for sorting
! 			 * is not relevant here.
  			 */
! 			if (peraggstate->transfn.fn_strict)
  			{
! 				for (i = 0; i < nargs; i++)
  				{
  					if (slot->tts_isnull[i])
  						break;
  				}
! 				if (i < nargs)
  					continue;
  			}
  
--- 529,552 ----
  
  		if (peraggstate->numSortCols > 0)
  		{
+ 			int numStrict = peraggstate->numStrict;
+ 
  			/* DISTINCT and/or ORDER BY case */
  			Assert(slot->tts_nvalid == peraggstate->numInputs);
  
  			/*
  			 * If the transfn is strict, we want to check for nullity before
  			 * storing the row in the sorter, to save space if there are a lot
! 			 * of nulls.
  			 */
! 			if (numStrict > 0)
  			{
! 				for (i = 0; i < numStrict; i++)
  				{
  					if (slot->tts_isnull[i])
  						break;
  				}
! 				if (i < numStrict)
  					continue;
  			}
  
***************
*** 534,539 **** advance_aggregates(AggState *aggstate, AggStatePerGroup pergroup)
--- 557,564 ----
  								   slot->tts_isnull[0]);
  			else
  				tuplesort_puttupleslot(peraggstate->sortstate, slot);
+ 
+ 			++peraggstate->number_of_rows;
  		}
  		else
  		{
***************
*** 756,768 **** finalize_aggregate(AggState *aggstate,
  	if (OidIsValid(peraggstate->finalfn_oid))
  	{
  		FunctionCallInfoData fcinfo;
  
! 		InitFunctionCallInfoData(fcinfo, &(peraggstate->finalfn), 1,
! 								 peraggstate->aggCollation,
! 								 (void *) aggstate, NULL);
! 		fcinfo.arg[0] = pergroupstate->transValue;
! 		fcinfo.argnull[0] = pergroupstate->transValueIsNull;
! 		if (fcinfo.flinfo->fn_strict && pergroupstate->transValueIsNull)
  		{
  			/* don't call a strict function with NULL inputs */
  			*resultVal = (Datum) 0;
--- 781,820 ----
  	if (OidIsValid(peraggstate->finalfn_oid))
  	{
  		FunctionCallInfoData fcinfo;
+ 		bool isnull = false;
+ 
+ 		if (!(peraggstate->aggref->isordset))
+ 		{
+ 			InitFunctionCallInfoData(fcinfo, &(peraggstate->finalfn), 1,
+ 								 	peraggstate->aggCollation,
+ 								 	(void *) aggstate, NULL);
+ 
+ 			fcinfo.arg[0] = pergroupstate->transValue;
+ 			fcinfo.argnull[0] = isnull = pergroupstate->transValueIsNull;
+ 		}
+ 		else
+ 		{
+ 			List     *args = peraggstate->aggrefstate->orddirectargs;
+ 			ListCell *lc;
+ 			int i = 0;
+ 
+ 			InitFunctionCallInfoData(fcinfo, &(peraggstate->finalfn), list_length(args),
+ 								 	peraggstate->aggCollation,
+ 								 	(void *) peraggstate, NULL);
+ 
+ 			foreach (lc, args)
+ 			{
+ 				ExprState *expr = (ExprState *) lfirst(lc);
+ 
+ 				fcinfo.arg[i] = ExecEvalExpr(expr, aggstate->ss.ps.ps_ExprContext,  &fcinfo.argnull[i], NULL);
+ 				if (fcinfo.argnull[i])
+ 					isnull = true;
  
! 				++i;
! 			}
! 		}
! 
! 		if (isnull && fcinfo.flinfo->fn_strict)
  		{
  			/* don't call a strict function with NULL inputs */
  			*resultVal = (Datum) 0;
***************
*** 1164,1169 **** agg_retrieve_direct(AggState *aggstate)
--- 1216,1232 ----
  		}
  
  		/*
+ 		 * Use the representative input tuple for any references to
+ 		 * non-aggregated input columns in the qual and tlist.	(If we are not
+ 		 * grouping, and there are no input rows at all, we will come here
+ 		 * with an empty firstSlot ... but if not grouping, there can't be any
+ 		 * references to non-aggregated input columns, so no problem.)
+ 		 * We do this before finalizing because for ordered set functions,
+ 		 * finalize_aggregates can evaluate arguments referencing the tuple.
+ 		 */
+ 		econtext->ecxt_outertuple = firstSlot;
+ 
+ 		/*
  		 * Done scanning input tuple group. Finalize each aggregate
  		 * calculation, and stash results in the per-output-tuple context.
  		 */
***************
*** 1174,1187 **** agg_retrieve_direct(AggState *aggstate)
  
  			if (peraggstate->numSortCols > 0)
  			{
! 				if (peraggstate->numInputs == 1)
! 					process_ordered_aggregate_single(aggstate,
! 													 peraggstate,
! 													 pergroupstate);
! 				else
! 					process_ordered_aggregate_multi(aggstate,
! 													peraggstate,
! 													pergroupstate);
  			}
  
  			finalize_aggregate(aggstate, peraggstate, pergroupstate,
--- 1237,1253 ----
  
  			if (peraggstate->numSortCols > 0)
  			{
! 				if (!(peraggstate->aggref->isordset))
! 				{
! 					if (peraggstate->numInputs == 1)
! 						process_ordered_aggregate_single(aggstate,
! 														 peraggstate,
! 														 pergroupstate);
! 					else
! 						process_ordered_aggregate_multi(aggstate,
! 														peraggstate,
! 														pergroupstate);
! 				}
  			}
  
  			finalize_aggregate(aggstate, peraggstate, pergroupstate,
***************
*** 1189,1203 **** agg_retrieve_direct(AggState *aggstate)
  		}
  
  		/*
- 		 * Use the representative input tuple for any references to
- 		 * non-aggregated input columns in the qual and tlist.	(If we are not
- 		 * grouping, and there are no input rows at all, we will come here
- 		 * with an empty firstSlot ... but if not grouping, there can't be any
- 		 * references to non-aggregated input columns, so no problem.)
- 		 */
- 		econtext->ecxt_outertuple = firstSlot;
- 
- 		/*
  		 * Check the qual (HAVING clause); if the group does not match, ignore
  		 * it and loop back to try to process another group.
  		 */
--- 1255,1260 ----
***************
*** 1580,1585 **** ExecInitAgg(Agg *node, EState *estate, int eflags)
--- 1637,1643 ----
  		Datum		textInitVal;
  		int			i;
  		ListCell   *lc;
+         bool        is_strict;
  
  		/* Planner should have assigned aggregate to correct level */
  		Assert(aggref->agglevelsup == 0);
***************
*** 1601,1606 **** ExecInitAgg(Agg *node, EState *estate, int eflags)
--- 1659,1667 ----
  		/* Nope, so assign a new PerAgg record */
  		peraggstate = &peragg[++aggno];
  
+ 		peraggstate->type = T_AggStatePerAggData;
+ 		peraggstate->aggstate = aggstate;
+ 
  		/* Mark Aggref state node with assigned index in the result array */
  		aggrefstate->aggno = aggno;
  
***************
*** 1644,1668 **** ExecInitAgg(Agg *node, EState *estate, int eflags)
  		peraggstate->transfn_oid = transfn_oid = aggform->aggtransfn;
  		peraggstate->finalfn_oid = finalfn_oid = aggform->aggfinalfn;
  
! 		/* Check that aggregate owner has permission to call component fns */
  		{
  			HeapTuple	procTuple;
  			Oid			aggOwner;
  
  			procTuple = SearchSysCache1(PROCOID,
  										ObjectIdGetDatum(aggref->aggfnoid));
  			if (!HeapTupleIsValid(procTuple))
  				elog(ERROR, "cache lookup failed for function %u",
  					 aggref->aggfnoid);
! 			aggOwner = ((Form_pg_proc) GETSTRUCT(procTuple))->proowner;
  			ReleaseSysCache(procTuple);
  
! 			aclresult = pg_proc_aclcheck(transfn_oid, aggOwner,
! 										 ACL_EXECUTE);
! 			if (aclresult != ACLCHECK_OK)
  				aclcheck_error(aclresult, ACL_KIND_PROC,
  							   get_func_name(transfn_oid));
! 			InvokeFunctionExecuteHook(transfn_oid);
  			if (OidIsValid(finalfn_oid))
  			{
  				aclresult = pg_proc_aclcheck(finalfn_oid, aggOwner,
--- 1705,1741 ----
  		peraggstate->transfn_oid = transfn_oid = aggform->aggtransfn;
  		peraggstate->finalfn_oid = finalfn_oid = aggform->aggfinalfn;
  
! 		/*
! 		 * Check that aggregate owner has permission to call component fns
! 		 * In passing, fetch the proisstrict flag for the aggregate proper,
! 		 * which subs for the transfn's strictness flag in cases where there
! 		 * is no transfn.
! 		 */
  		{
  			HeapTuple	procTuple;
  			Oid			aggOwner;
+ 			Form_pg_proc procp;
  
  			procTuple = SearchSysCache1(PROCOID,
  										ObjectIdGetDatum(aggref->aggfnoid));
  			if (!HeapTupleIsValid(procTuple))
  				elog(ERROR, "cache lookup failed for function %u",
  					 aggref->aggfnoid);
! 			procp = (Form_pg_proc) GETSTRUCT(procTuple);
! 			aggOwner = procp->proowner;
! 			is_strict = procp->proisstrict;
  			ReleaseSysCache(procTuple);
  
! 			if (OidIsValid(transfn_oid))
! 			{
! 				aclresult = pg_proc_aclcheck(transfn_oid, aggOwner,
! 									         ACL_EXECUTE);
! 				if (aclresult != ACLCHECK_OK && OidIsValid(transfn_oid))
  				aclcheck_error(aclresult, ACL_KIND_PROC,
  							   get_func_name(transfn_oid));
! 				InvokeFunctionExecuteHook(transfn_oid);
! 			}
! 
  			if (OidIsValid(finalfn_oid))
  			{
  				aclresult = pg_proc_aclcheck(finalfn_oid, aggOwner,
***************
*** 1676,1682 **** ExecInitAgg(Agg *node, EState *estate, int eflags)
  
  		/* resolve actual type of transition state, if polymorphic */
  		aggtranstype = aggform->aggtranstype;
! 		if (IsPolymorphicType(aggtranstype))
  		{
  			/* have to fetch the agg's declared input types... */
  			Oid		   *declaredArgTypes;
--- 1749,1755 ----
  
  		/* resolve actual type of transition state, if polymorphic */
  		aggtranstype = aggform->aggtranstype;
! 		if (OidIsValid(aggtranstype) && IsPolymorphicType(aggtranstype))
  		{
  			/* have to fetch the agg's declared input types... */
  			Oid		   *declaredArgTypes;
***************
*** 1704,1711 **** ExecInitAgg(Agg *node, EState *estate, int eflags)
  								&transfnexpr,
  								&finalfnexpr);
  
! 		fmgr_info(transfn_oid, &peraggstate->transfn);
! 		fmgr_info_set_expr((Node *) transfnexpr, &peraggstate->transfn);
  
  		if (OidIsValid(finalfn_oid))
  		{
--- 1777,1789 ----
  								&transfnexpr,
  								&finalfnexpr);
  
! 		if (OidIsValid(transfn_oid))
! 		{
! 			fmgr_info(transfn_oid, &peraggstate->transfn);
! 			fmgr_info_set_expr((Node *) transfnexpr, &peraggstate->transfn);
! 
! 			is_strict = peraggstate->transfn.fn_strict;
! 		}
  
  		if (OidIsValid(finalfn_oid))
  		{
***************
*** 1713,1726 **** ExecInitAgg(Agg *node, EState *estate, int eflags)
  			fmgr_info_set_expr((Node *) finalfnexpr, &peraggstate->finalfn);
  		}
  
  		peraggstate->aggCollation = aggref->inputcollid;
  
  		get_typlenbyval(aggref->aggtype,
  						&peraggstate->resulttypeLen,
  						&peraggstate->resulttypeByVal);
! 		get_typlenbyval(aggtranstype,
! 						&peraggstate->transtypeLen,
! 						&peraggstate->transtypeByVal);
  
  		/*
  		 * initval is potentially null, so don't try to access it as a struct
--- 1791,1814 ----
  			fmgr_info_set_expr((Node *) finalfnexpr, &peraggstate->finalfn);
  		}
  
+ 		if (is_strict)
+ 		{
+ 			peraggstate->numStrict = (peraggstate->aggref->isordset ? numInputs : numArguments);
+ 		}
+ 		else
+ 			peraggstate->numStrict = 0;
+ 
  		peraggstate->aggCollation = aggref->inputcollid;
  
  		get_typlenbyval(aggref->aggtype,
  						&peraggstate->resulttypeLen,
  						&peraggstate->resulttypeByVal);
! 		if (OidIsValid(aggtranstype))
! 		{
! 			get_typlenbyval(aggtranstype,
! 							&peraggstate->transtypeLen,
! 							&peraggstate->transtypeByVal);
! 		}
  
  		/*
  		 * initval is potentially null, so don't try to access it as a struct
***************
*** 1743,1749 **** ExecInitAgg(Agg *node, EState *estate, int eflags)
  		 * transValue.	This should have been checked at agg definition time,
  		 * but just in case...
  		 */
! 		if (peraggstate->transfn.fn_strict && peraggstate->initValueIsNull)
  		{
  			if (numArguments < 1 ||
  				!IsBinaryCoercible(inputTypes[0], aggtranstype))
--- 1831,1839 ----
  		 * transValue.	This should have been checked at agg definition time,
  		 * but just in case...
  		 */
! 		if (OidIsValid(peraggstate->transfn_oid)
! 			&& peraggstate->transfn.fn_strict
! 			&& peraggstate->initValueIsNull)
  		{
  			if (numArguments < 1 ||
  				!IsBinaryCoercible(inputTypes[0], aggtranstype))
***************
*** 1804,1810 **** ExecInitAgg(Agg *node, EState *estate, int eflags)
  			/* If we have only one input, we need its len/byval info. */
  			if (numInputs == 1)
  			{
! 				get_typlenbyval(inputTypes[0],
  								&peraggstate->inputtypeLen,
  								&peraggstate->inputtypeByVal);
  			}
--- 1894,1900 ----
  			/* If we have only one input, we need its len/byval info. */
  			if (numInputs == 1)
  			{
! 				get_typlenbyval(peraggstate->evaldesc->attrs[0]->atttypid,
  								&peraggstate->inputtypeLen,
  								&peraggstate->inputtypeByVal);
  			}
***************
*** 2039,2044 **** AggCheckCallContext(FunctionCallInfo fcinfo, MemoryContext *aggcontext)
--- 2129,2141 ----
  		return AGG_CONTEXT_WINDOW;
  	}
  
+ 	if (fcinfo->context && IsA(fcinfo->context, AggStatePerAggData))
+ 	{
+ 		if (aggcontext)
+ 			*aggcontext = ((AggStatePerAggData *) fcinfo->context)->aggstate->aggcontext;
+ 		return AGG_CONTEXT_ORDERED;
+ 	}
+ 
  	/* this is just to prevent "uninitialized variable" warnings */
  	if (aggcontext)
  		*aggcontext = NULL;
***************
*** 2062,2064 **** aggregate_dummy(PG_FUNCTION_ARGS)
--- 2159,2209 ----
  		 fcinfo->flinfo->fn_oid);
  	return (Datum) 0;			/* keep compiler quiet */
  }
+ 
+ /* AggSetGetRowCount - Get the number of rows in case of ordered set
+  * functions.
+  */
+ int64
+ AggSetGetRowCount(FunctionCallInfo fcinfo)
+ {
+ 	if (fcinfo->context && IsA(fcinfo->context, AggStatePerAggData))
+ 	{
+ 		return ((AggStatePerAggData *)fcinfo->context)->number_of_rows;
+ 	}
+ 
+ 	elog(ERROR, "Called AggSetGetRowCount on non ordered set function");
+ 	return -1;
+ }
+ 
+ /* AggSetGetSortInfo - Get the sort state in the case of 
+  * ordered set functions.
+  */
+ void
+ AggSetGetSortInfo(FunctionCallInfo fcinfo, Tuplesortstate **sortstate, TupleDesc *tupdesc, TupleTableSlot **tupslot, Oid *datumtype)
+ {
+ 	if (fcinfo->context && IsA(fcinfo->context, AggStatePerAggData))
+ 	{
+ 		AggStatePerAggData *peraggstate = (AggStatePerAggData *) fcinfo->context;
+ 
+ 		*sortstate = peraggstate->sortstate;
+ 		if (peraggstate->numInputs == 1)
+ 		{
+ 			if (tupdesc)
+ 				*tupdesc = NULL;
+ 			*datumtype = peraggstate->evaldesc->attrs[0]->atttypid;
+ 		}
+ 		else
+ 		{
+ 			if (tupdesc)
+ 				*tupdesc = peraggstate->evaldesc;
+ 			*datumtype = InvalidOid;
+ 		}
+ 		
+ 		if (tupslot)
+ 			*tupslot = peraggstate->evalslot;
+ 	}
+ 	else
+ 	{
+ 		elog(ERROR, "AggSetSortInfo called on non ordered set function");
+ 	}
+ }
*** a/src/backend/nodes/copyfuncs.c
--- b/src/backend/nodes/copyfuncs.c
***************
*** 1138,1145 **** _copyAggref(const Aggref *from)
--- 1138,1147 ----
  	COPY_NODE_FIELD(args);
  	COPY_NODE_FIELD(aggorder);
  	COPY_NODE_FIELD(aggdistinct);
+ 	COPY_NODE_FIELD(orddirectargs);
  	COPY_NODE_FIELD(aggfilter);
  	COPY_SCALAR_FIELD(aggstar);
+ 	COPY_SCALAR_FIELD(isordset);
  	COPY_SCALAR_FIELD(agglevelsup);
  	COPY_LOCATION_FIELD(location);
  
***************
*** 2171,2176 **** _copyFuncCall(const FuncCall *from)
--- 2173,2179 ----
  	COPY_SCALAR_FIELD(agg_star);
  	COPY_SCALAR_FIELD(agg_distinct);
  	COPY_SCALAR_FIELD(func_variadic);
+ 	COPY_SCALAR_FIELD(has_within_group);
  	COPY_NODE_FIELD(over);
  	COPY_LOCATION_FIELD(location);
  
*** a/src/backend/nodes/equalfuncs.c
--- b/src/backend/nodes/equalfuncs.c
***************
*** 196,203 **** _equalAggref(const Aggref *a, const Aggref *b)
--- 196,205 ----
  	COMPARE_NODE_FIELD(args);
  	COMPARE_NODE_FIELD(aggorder);
  	COMPARE_NODE_FIELD(aggdistinct);
+ 	COMPARE_NODE_FIELD(orddirectargs);
  	COMPARE_NODE_FIELD(aggfilter);
  	COMPARE_SCALAR_FIELD(aggstar);
+ 	COMPARE_SCALAR_FIELD(isordset);
  	COMPARE_SCALAR_FIELD(agglevelsup);
  	COMPARE_LOCATION_FIELD(location);
  
***************
*** 2001,2006 **** _equalFuncCall(const FuncCall *a, const FuncCall *b)
--- 2003,2009 ----
  	COMPARE_SCALAR_FIELD(agg_star);
  	COMPARE_SCALAR_FIELD(agg_distinct);
  	COMPARE_SCALAR_FIELD(func_variadic);
+ 	COMPARE_SCALAR_FIELD(has_within_group);
  	COMPARE_NODE_FIELD(over);
  	COMPARE_LOCATION_FIELD(location);
  
*** a/src/backend/nodes/makefuncs.c
--- b/src/backend/nodes/makefuncs.c
***************
*** 530,535 **** makeFuncCall(List *name, List *args, int location)
--- 530,536 ----
  	n->agg_star = FALSE;
  	n->agg_distinct = FALSE;
  	n->func_variadic = FALSE;
+ 	n->has_within_group = FALSE;
  	n->over = NULL;
  	return n;
  }
*** a/src/backend/nodes/nodeFuncs.c
--- b/src/backend/nodes/nodeFuncs.c
***************
*** 1572,1577 **** expression_tree_walker(Node *node,
--- 1572,1582 ----
  				if (expression_tree_walker((Node *) expr->aggdistinct,
  										   walker, context))
  					return true;
+ 
+ 				if (expression_tree_walker((Node *) expr->orddirectargs,
+ 										   walker, context))
+ 					return true;
+ 
  				if (walker((Node *) expr->aggfilter, context))
  					return true;
  			}
***************
*** 2096,2102 **** expression_tree_mutator(Node *node,
--- 2101,2109 ----
  				MUTATE(newnode->args, aggref->args, List *);
  				MUTATE(newnode->aggorder, aggref->aggorder, List *);
  				MUTATE(newnode->aggdistinct, aggref->aggdistinct, List *);
+ 				MUTATE(newnode->orddirectargs, aggref->orddirectargs, List *);
  				MUTATE(newnode->aggfilter, aggref->aggfilter, Expr *);
+ 
  				return (Node *) newnode;
  			}
  			break;
*** a/src/backend/nodes/outfuncs.c
--- b/src/backend/nodes/outfuncs.c
***************
*** 959,966 **** _outAggref(StringInfo str, const Aggref *node)
--- 959,968 ----
  	WRITE_NODE_FIELD(args);
  	WRITE_NODE_FIELD(aggorder);
  	WRITE_NODE_FIELD(aggdistinct);
+ 	WRITE_NODE_FIELD(orddirectargs);
  	WRITE_NODE_FIELD(aggfilter);
  	WRITE_BOOL_FIELD(aggstar);
+ 	WRITE_BOOL_FIELD(isordset);
  	WRITE_UINT_FIELD(agglevelsup);
  	WRITE_LOCATION_FIELD(location);
  }
***************
*** 2087,2092 **** _outFuncCall(StringInfo str, const FuncCall *node)
--- 2089,2095 ----
  	WRITE_BOOL_FIELD(agg_star);
  	WRITE_BOOL_FIELD(agg_distinct);
  	WRITE_BOOL_FIELD(func_variadic);
+ 	WRITE_BOOL_FIELD(has_within_group);
  	WRITE_NODE_FIELD(over);
  	WRITE_LOCATION_FIELD(location);
  }
*** a/src/backend/nodes/readfuncs.c
--- b/src/backend/nodes/readfuncs.c
***************
*** 495,502 **** _readAggref(void)
--- 495,504 ----
  	READ_NODE_FIELD(args);
  	READ_NODE_FIELD(aggorder);
  	READ_NODE_FIELD(aggdistinct);
+ 	READ_NODE_FIELD(orddirectargs);
  	READ_NODE_FIELD(aggfilter);
  	READ_BOOL_FIELD(aggstar);
+ 	READ_BOOL_FIELD(isordset);
  	READ_UINT_FIELD(agglevelsup);
  	READ_LOCATION_FIELD(location);
  
*** a/src/backend/optimizer/util/clauses.c
--- b/src/backend/optimizer/util/clauses.c
***************
*** 486,492 **** count_agg_clauses_walker(Node *node, count_agg_clauses_context *context)
  			costs->numOrderedAggs++;
  
  		/* add component function execution costs to appropriate totals */
! 		costs->transCost.per_tuple += get_func_cost(aggtransfn) * cpu_operator_cost;
  		if (OidIsValid(aggfinalfn))
  			costs->finalCost += get_func_cost(aggfinalfn) * cpu_operator_cost;
  
--- 486,493 ----
  			costs->numOrderedAggs++;
  
  		/* add component function execution costs to appropriate totals */
! 		if (OidIsValid(aggtransfn))
! 			costs->transCost.per_tuple += get_func_cost(aggtransfn) * cpu_operator_cost;
  		if (OidIsValid(aggfinalfn))
  			costs->finalCost += get_func_cost(aggfinalfn) * cpu_operator_cost;
  
***************
*** 516,522 **** count_agg_clauses_walker(Node *node, count_agg_clauses_context *context)
  		}
  
  		/* resolve actual type of transition state, if polymorphic */
! 		if (IsPolymorphicType(aggtranstype))
  		{
  			/* have to fetch the agg's declared input types... */
  			Oid		   *declaredArgTypes;
--- 517,523 ----
  		}
  
  		/* resolve actual type of transition state, if polymorphic */
! 		if (OidIsValid(aggtranstype) && IsPolymorphicType(aggtranstype))
  		{
  			/* have to fetch the agg's declared input types... */
  			Oid		   *declaredArgTypes;
***************
*** 539,545 **** count_agg_clauses_walker(Node *node, count_agg_clauses_context *context)
  		 * pass-by-reference then we have to add the estimated size of the
  		 * value itself, plus palloc overhead.
  		 */
! 		if (!get_typbyval(aggtranstype))
  		{
  			int32		aggtranstypmod;
  			int32		avgwidth;
--- 540,546 ----
  		 * pass-by-reference then we have to add the estimated size of the
  		 * value itself, plus palloc overhead.
  		 */
! 		if (OidIsValid(aggtranstype) && !get_typbyval(aggtranstype))
  		{
  			int32		aggtranstypmod;
  			int32		avgwidth;
***************
*** 3882,3888 **** recheck_cast_function_args(List *args, Oid result_type, HeapTuple func_tuple)
  		elog(ERROR, "function's resolved result type changed during planning");
  
  	/* perform any necessary typecasting of arguments */
! 	make_fn_arguments(NULL, args, actual_arg_types, declared_arg_types);
  }
  
  /*
--- 3883,3889 ----
  		elog(ERROR, "function's resolved result type changed during planning");
  
  	/* perform any necessary typecasting of arguments */
! 	make_fn_arguments(NULL, args, NULL, actual_arg_types, declared_arg_types);
  }
  
  /*
*** a/src/backend/parser/gram.y
--- b/src/backend/parser/gram.y
***************
*** 493,498 **** static Node *makeRecursiveViewSelect(char *relname, List *aliases, Node *query);
--- 493,499 ----
  %type <str>		opt_existing_window_name
  %type <boolean> opt_if_not_exists
  %type <node>    filter_clause
+ %type <list> 	within_group_clause
  
  /*
   * Non-keyword token types.  These are hard-wired into the "flex" lexer.
***************
*** 595,601 **** static Node *makeRecursiveViewSelect(char *relname, List *aliases, Node *query);
  	VACUUM VALID VALIDATE VALIDATOR VALUE_P VALUES VARCHAR VARIADIC VARYING
  	VERBOSE VERSION_P VIEW VOLATILE
  
! 	WHEN WHERE WHITESPACE_P WINDOW WITH WITHOUT WORK WRAPPER WRITE
  
  	XML_P XMLATTRIBUTES XMLCONCAT XMLELEMENT XMLEXISTS XMLFOREST XMLPARSE
  	XMLPI XMLROOT XMLSERIALIZE
--- 596,602 ----
  	VACUUM VALID VALIDATE VALIDATOR VALUE_P VALUES VARCHAR VARIADIC VARYING
  	VERBOSE VERSION_P VIEW VOLATILE
  
! 	WHEN WHERE WITHIN WHITESPACE_P WINDOW WITH WITHOUT WORK WRAPPER WRITE
  
  	XML_P XMLATTRIBUTES XMLCONCAT XMLELEMENT XMLEXISTS XMLFOREST XMLPARSE
  	XMLPI XMLROOT XMLSERIALIZE
***************
*** 9413,9418 **** sortby:		a_expr USING qual_all_Op opt_nulls_order
--- 9414,9424 ----
  		;
  
  
+ within_group_clause:
+ 			WITHIN GROUP_P '(' sort_clause ')'  { $$ = $4; }
+ 			| /*EMPTY*/                         { $$ = NULL; }
+          ;
+ 
  select_limit:
  			limit_clause offset_clause			{ $$ = list_make2($2, $1); }
  			| offset_clause limit_clause		{ $$ = list_make2($1, $2); }
***************
*** 11112,11122 **** func_application: func_name '(' ')'
   * (Note that many of the special SQL functions wouldn't actually make any
   * sense as functional index entries, but we ignore that consideration here.)
   */
! func_expr: func_application filter_clause over_clause 
  				{
                		FuncCall *n = (FuncCall*)$1;
! 					n->agg_filter = $2;
! 					n->over = $3;
  					$$ = (Node*)n;
  				} 
  			| func_expr_common_subexpr
--- 11118,11151 ----
   * (Note that many of the special SQL functions wouldn't actually make any
   * sense as functional index entries, but we ignore that consideration here.)
   */
! func_expr: func_application within_group_clause filter_clause over_clause 
  				{
                		FuncCall *n = (FuncCall*)$1;
! 					/*
! 					 * the order clause for WITHIN GROUP and the one
! 					 * for aggregate ORDER BY share a field, so we
! 					 * have to check here that at most one is present.
! 					 * We check for DISTINCT here to give a better
! 					 * error position.  Other consistency checks are
! 					 * deferred to parse_func.c or parse_agg.c
! 					 */
! 					if ($2)
! 					{
! 						if (n->agg_order)
! 							ereport(ERROR,
! 									(errcode(ERRCODE_SYNTAX_ERROR),
! 									 errmsg("Cannot have multiple ORDER BY clauses with WITHIN GROUP"),
! 									 parser_errposition(@2)));
! 						if (n->agg_distinct)
! 							ereport(ERROR,
! 									(errcode(ERRCODE_SYNTAX_ERROR),
! 									 errmsg("Cannot have DISTINCT and WITHIN GROUP together"),
! 									 parser_errposition(@2)));
! 						n->agg_order = $2;
! 						n->has_within_group = TRUE;
! 					}
! 					n->agg_filter = $3;
! 					n->over = $4;
  					$$ = (Node*)n;
  				} 
  			| func_expr_common_subexpr
***************
*** 12675,12680 **** unreserved_keyword:
--- 12704,12710 ----
  			| VIEW
  			| VOLATILE
  			| WHITESPACE_P
+ 			| WITHIN
  			| WITHOUT
  			| WORK
  			| WRAPPER
